EDIT - task #7316

[E+M] Handle name relations correctly
03/16/2018 09:56 AM - Andreas Mdller

Status: Resolved Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 90%
Category: data Estimated time: 0:30 hour
Target version: Euro+Med Portal Release

Severity: normal

Description

Decision:

e we export ALL fromNames not yet in taxon export (ERS: also later homonyms might be of interest)
¢ we export all toNames with qualifier 2, 4, 5, 13, 14, 15, 17, 18, 37, 62 (4,5,13,14,37 should not exist anyway, 62 should be
selfreferencing)

Currently in v_cdm_exp_namesRelatedTo we export all name relations of type

1 is basionym for => questionable as all new combinations should be also synonyms (but maybe similar names were mixed up
sometimes?)

2 is later homonym of !l => anyway check if there is not maybe a duplicate

3 is replaced synonym for => questionable as all nom. nov. should be also synonyms (but maybe similar names were mixed up
sometimes?)

9 is first parent of => questionable if hybrids of accepted taxa should be exported too if not being an explicit taxon

10 is second parent of => see 9)

16 is orthographic variant of => this should not happen as the taxa/synonyms should not be variants

The following relations we do not export because: looks like they all do not have data that do not yet exist as taxa

4 is validation of

5 is later validation of
6 is type of

7 is conserved type of
8 is rejected type of

11 is female parent of

12 is male parent of

13 is conserved against

14 is rejected in favour of

15 is treated as later homonym of
17 is alternative name for

18 has same type as

37 is later isonym of

61 is lectotype of

62 type not designated

SELECT rel.RelNameQualifierFk, count (*) as n
FROM RelName rel

—— WHERE

——(rel.NameFkl IN (SELECT PTNameFk AS NameId
e FROM dbo.v_cdm_exp_taxaAll))
GROUP BY rel.RelNameQualifierFk

ORDER BY rel.RelNameQualifierFk

SELECT nl.FullNameCache fromName, nl.Created_Who, nl.namelId, n2.NameCache toName, n2.FullNameCache

toNameAuthor, n2.created_Who, n2.namelId, rel.RelNameld, rel.RefFk relRef, rel.RelNameQualifierFk,
ta.RIdentifier, ta.PTRefFk

FROM RelName rel INNER JOIN v_cdm_exp_taxaAll ta ON ta.PTNameFk = rel.NameFkl

INNER JOIN Name nl ON nl.namelId = rel.NameFkl
INNER JOIN Name n2 ON n2.nameld = rel.NameFk2

WHERE n2.namelId NOT IN (SELECT ta2.PTNameFk FROM v_cdm_exp_taxaAll ta2)

—— AND n2.NameCache IN (SELECT nn.NameCache FROM v_cdm_exp_taxaAll ta2 INNER JOIN Name nn ON ta2.P
TNameFk = nn.NamelId )

ORDER BY RelNameQualifierFk, ta.PTRefFk, nl.FullNameCache

v_cdm_exp_namesRelatedFrom:

SELECT nl.FullNameCache fromName, nl.Created_Who, nl.namelId, n2.NameCache toName, n2.
FullNameCache nomNovtoNameAuthor, n2.created_Who, n2.nameld, rel.RelNamelId, rel.RefFk relRef, rel
.RelNameQualifierFk, g.RelNameQualifier, ta.RIdentifier, ta.PTRefFk

FROM RelName rel INNER JOIN v_cdm_exp_taxaAll ta ON ta.PTNameFk = rel.NameFk2

INNER JOIN Name nl ON nl.namelId = rel.NameFkl

INNER JOIN Name n2 ON n2.nameld = rel.NameFk2

INNER JOIN RelNameQualifier g ON g.RelNameQualifierId = rel.RelNameQualifierFk

WHERE nl.nameId NOT IN (SELECT ta2.PTNameFk FROM v_cdm_exp_taxaAll ta2)

ta2.PTNameFk = nn.Nameld )

—— AND RelNameQualifierFk NOT IN (2, 16)

—— AND RelNameQualifierFk IN (3)

ORDER BY RelNameQualifierFk, ta.PTRefFk, nl.FullNameCache

Potential homonym duplicates:

SELECT nl.FullNameCache laterHomonym, nl.Created_Who laterHomonymCreated, nl.namelId laterHomonymId
, n2.NameCache earlierName, n2.FullNameCache earlierNameAuthor, n2.created_Who
earlierNameCreated, n2.nameld earlierNamelId, rel.RelNameld, rel.RefFk relRef, rel.
RelNameQualifierFk, g.RelNameQualifier, ta.RIdentifier, ta.PTRefFk

FROM RelName rel INNER JOIN v_cdm_exp_taxaAll ta ON ta.PTNameFk = rel.NameFk2

INNER JOIN Name nl ON nl.namelId = rel.NameFkl

INNER JOIN Name n2 ON n2.nameld = rel.NameFk2

INNER JOIN RelNameQualifier g ON g.RelNameQualifierId = rel.RelNameQualifierFk

WHERE nl.nameId NOT IN (SELECT ta2.PTNameFk FROM v_cdm_exp_taxaAll ta2)

AND EXISTS (SELECT nn.NameCache FROM v_cdm_exp_taxaAll ta2 INNER JOIN Name nn ON taZ2.PTNameFk =
nn.NameId WHERE nn.nameId <> nl.namelId AND nn.namelId <> n2.nameld AND nn.NameCache = n2.NameCache
AND nn.nameCache <> nn.FullNameCache)

AND RelNameQualifierFk IN (2)

—— AND (nl.FullNameCache > 'Geranium laevigatum DC.' OR PTRefFk > 7400000) AND PTRefFk > 7300000
ORDER BY RelNameQualifierFk, ta.PTRefFk, nl.FullNameCache

Homonym candidates:

SELECT NamelId, rd.FullNomRefCache, FullNameCache, pt.PTRefFk, rd.FullRefCache, at.
AuthorTeamCache, at.FullAuthorTeamCache, RankFk, NameCache, UnnamedNamePhrase, n.PreliminaryFlag,
SupragenericName, Genus, GenusSubdivisionEpi, SpeciesEpi, InfraSpeciesEpi, AuthorTeamFk,
ExAuthorTeamFk,

BasAuthorTeamFk, ExBasAuthorTeamFk, HybridFormulaFlag, MonomHybFlag,
BinomHybFlag, TrinomHybFlag, CultivarGroupName, CultivarName, NomRefFk, NomRefDetailFk,
NameSourceRefFk, Source_Acc,

n.Created_When, n.Created_Who, n.Notes, ParsingComments, OldNomRefFk,
OldNomRefDetailFk, n.Updated_Who, OrthoProjection, HybridFormula, TempKewId, n.uuid
FROM Name n
LEFT OUTER JOIN RefDetail rd ON rd.RefDetailld = n.NomRefDetailFk
LEFT OUTER JOIN AuthorTeam at ON at.AuthorTeamId = n.AuthorTeamFk
LEFT OUTER JOIN PTaxon pt ON pt.PTNameFk = n.Nameld
WHERE (NameId IN (-1)) OR

(FullNameCache LIKE 'Taraxacum laciniatum%')

ORDER BY FullNameCache, PTRefFk, NamelID

Update:

SELECT TOP (200) RelNameId, NameFkl, NameFk2, RelNameQualifierFk, RefFk, RefDetailFk,
Created_When, Updated_When, Created_Who, Updated_Who, Notes

FROM RelName

WHERE (RelNameId IN (0)) OR

(NameFk2 IN (7534221)) OR
(NameFkl IN (0))
Alternative name:
Der eine "is alternative name for" Fall wird in #7317 abgehandelt.

Suche von ungehandelten Fallen im Import Log:

SELECT NameId as AllNames

FROM v_cdm_exp_namesAll

WHERE (NameId IN (95621, 7300008, 58609));

SELECT NameId as relFrom, toName

FROM v_cdm_exp_namesRelatedFrom v

WHERE (NameId IN (95621, 7300008, 58609));

SELECT NameId as relTo , rel.RelNameId relld, rel.NameFkl fromId, rel.RelNameQualifierFk
type

FROM v_cdm_exp_namesRelatedto v LEFT OUTER JOIN RelName rel ON rel.NameFk2 = v.NamelId
WHERE (NameId IN (95621, 58609));

SELECT NameId as commonName, v.NamelId

FROM v_cdm_exp_namesCommonNameSource v

WHERE (NameId IN (95621, 58609));

SELECT ta.PTNameFk AS taxon, ta.PTRefFk, pt.StatusFk

FROM dbo.v_cdm_exp_taxaAll ta LEFT OUTER JOIN PTaxon pt ON pt.RIdentifier = ta.
RIdentifier

WHERE ta.PTNameFk IN (95621, 58609, 95623)

7

SELECT *

FROM Name

WHERE NameID IN (95621, 58609, 7300008);

SELECT *
FROM RelName rel
WHERE rel.NameFkl IN (7300008, 7300009, 58609) OR rel.NameFkl IN (7300008, 7300009, 58609)

Associated revisions

Revision 09539dc4 - 06/02/2018 12:49 PM - Andreas Miiller

fix #7316 final fix for name relations import

History

#1 - 03/16/2018 09:57 AM - Andreas Miiller

- Description updated

#2 - 03/16/2018 12:31 PM - Andreas Miuller

- Description updated

#3 - 03/16/2018 01:27 PM - Andreas Miuller

- Description updated

#4 - 03/16/2018 01:50 PM - Andreas Miuller

- Description updated

#5 - 03/16/2018 02:10 PM - Andreas Miuller

- Description updated

#6 - 03/16/2018 02:11 PM - Andreas Miuller

- Description updated

#7 - 03/16/2018 02:13 PM - Andreas Miiller

- Subject changed from [E+M] Select correct name relations for export to [E+M] Handle name relations correctly
#8 - 03/16/2018 02:53 PM - Andreas Miiller

- Description updated

#9 - 03/16/2018 02:53 PM - Andreas Miiller

- Description updated

#10 - 03/16/2018 02:54 PM - Andreas Miiller

- Description updated

#11 - 03/19/2018 05:22 PM - Andreas Miiller

- Description updated

#12 - 03/19/2018 05:28 PM - Andreas Miiller

- Description updated

#13 - 03/19/2018 06:06 PM - Andreas Miiller

- Description updated

#14 - 03/19/2018 06:10 PM - Andreas Miiller

- Description updated

#15 - 03/19/2018 06:13 PM - Andreas Miiller

- Description updated

#16 - 03/23/2018 09:56 PM - Andreas Miiller

- Status changed from New to In Progress

#17 - 03/23/2018 09:56 PM - Andreas Miiller
- % Done changed from 0 to 20

#18 - 05/09/2018 03:21 PM - Andreas Miiller
- % Done changed from 20 to 70
- Estimated time set to 10:00 h

#20 - 05/25/2018 12:23 PM - Andreas Miiller

- Estimated time changed from 10:00 h to 2:00 h

#21 - 05/25/2018 12:23 PM - Andreas Miiller
- Priority changed from New to Highest

#22 - 05/30/2018 01:45 PM - Andreas Miiller

- Description updated

#23 - 05/30/2018 01:45 PM - Andreas Miiller

- Description updated

#24 - 06/02/2018 12:10 PM - Andreas Miiller

- Description updated

#25 - 06/02/2018 12:10 PM - Andreas Miiller
- % Done changed from 70 to 90
- Estimated time changed from 2:00 h to 0:30 h

#26 - 06/02/2018 12:48 PM - Andreas Miiller
- Description updated
#27 - 06/02/2018 12:48 PM - Andreas Miiller

- Description updated

#28 - 06/02/2018 12:50 PM - Andreas Miiller
- Status changed from In Progress to Resolved

- % Done changed from 90 to 50

Applied in changeset cdmlib-apps|09539dc4fba8474bb74c0d0f67fac92412e708f9.

#29 - 06/02/2018 12:51 PM - Andreas Miiller
- % Done changed from 50 to 90

#30 - 06/03/2018 07:41 PM - Andreas Miiller

- Description updated
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdmlib-apps/revisions/09539dc4fba8474bb74c0d0f67fac92412e708f9
http://www.tcpdf.org

